/************************************************************************************
barre2.5: permet d'avoir des information dans la barre de titre des xterm sous Linux
	(date et heure, load avrage, nombre de users,nombre de mail recu)
Copyright (C) 1998 Damien Piquet (Dams@altavista.net)
------------------------------------------------------------------------------------
	This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

	This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
************************************************************************************/


#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <locale.h>
#include <nl_types.h>
#include <time.h>
#include <utmp.h>
#include <linux/sys.h>
#include <linux/kernel.h>	
#include <unistd.h>
#include <dirent.h>

char retour[30];
char datfr[50];
char nbuser[10];
char strAvg[15];
int taille=0;
int nbmail=0;
int debut=1;



void ecritbarre(char *texte){
	int fd;
	char dev[50];
	char barre[255];

	strcpy(dev,ttyname(0));
	fd=open(dev,O_RDWR);
	if (fd!=-1){
		sprintf(barre,"]2;%s",texte);
		write(fd,barre,strlen(barre));
		sleep(10);
		close(fd);
	}
	else perror("erreur ouverture fd de fenetre");
}

char *mail(){

	int fdm;
	int lg;
	register int ttt=0;
	register int i,j=0;
	char name[255];
	char ligne[255];
	char from[255];
	char fromtmp[255];
	char from2[255];
	struct stat stat_tampon;
	FILE *fichier;

	if (getlogin()){
		strcpy(name,"/var/spool/mail/");
		strcat(name,getlogin());
		if (access(name,F_OK)==0){ /*si le fichier existe*/
			if((fdm = open(name,O_RDONLY)) == -1){ /*on ouvre le fichier*/
				perror("Erreur a l'ouverture du fichier de mail");
				exit(1);
			}

			if (fstat(fdm,&stat_tampon) ==0){ /*on recupere les infos du fichier*/
				if ((stat_tampon.st_size) > 0){ /*si la taille est sup a 0*/
					if(stat_tampon.st_size!=taille){	/* s'il y a un changement dans la taille */
						if ((stat_tampon.st_size>taille)&&(debut==0)){
							fichier=fopen(name,"r");
							if (fichier==NULL){
								perror("Erreur ouverture de fichier mail");
							}else{
								while(ttt!=EOF){
									ttt=fgetc(fichier);
									ungetc(ttt,fichier);
									fgets(ligne,255,fichier);
									if(strncmp(ligne,"From:",strlen("From:"))==0)
										strcpy(from,ligne);
								}
								for (i=5;i<(strlen(from));i++){
									fromtmp[j]=from[i];
									j++;
								}
								fromtmp[strlen(from)-6]='\0';
								sprintf(from2,"Nouveau mail de %s",fromtmp);
								ecritbarre(from2);
							}	
							fclose(fichier);
							ttt=0;
						}

						nbmail=0;
						taille=stat_tampon.st_size;
						fichier=fopen(name,"r");
						if (fichier==NULL){
							perror("Erreur ouverture de fichier mail");
						}else{
							while(ttt!=EOF){
								ttt=fgetc(fichier);
								ungetc(ttt,fichier);
								fgets(ligne,255,fichier);
								if(strncmp(ligne,"From ",strlen("From "))==0)
									nbmail++;
							}	
						}	
						fclose(fichier);
					}	

					if (nbmail>1){
						sprintf(retour,"%i mails! Taille: %d",nbmail,stat_tampon.st_size);
					}else
						sprintf(retour,"%i mail! Taille: %d",nbmail,stat_tampon.st_size);
				}else	
					strcpy(retour,"Pas de mail");
			}else
				perror("Appel systeme stat");
			close(fdm);
		}else
			strcpy(retour,"Pas de mail");
	}else 
		strcpy(retour,"(Pas d'indication de mail)");
	retour[strlen(retour)]='\0';
	debut=0;
	return (retour);
}


char *datefr(){
	/* oblige de faire ca car tout les linux integrent pas encore le locale */
	char ttjour[7][10]={"Dimanche","Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi"};
	char ttmois[12][10]={"Janvier","Fevrier","Mars","Avril","Mai","Juin",
		"Juillet","Aout","Septembre","Octobre","Novembre","Decembre"};
	struct tm date;
	time_t d_t;
	char temp[5];
	int jour;
	int mois;
	int quant;
	char sJour[10];
	char sMois[10];
	char fin[20];

	setlocale(LC_TIME,"french");
	d_t=time((void *)0);	/*date*/
	date=*localtime(&d_t);	/*date format struct tm*/

	strftime(temp,5,"%w",&date);
	jour=atoi(temp);	
	strftime(temp,5,"%m",&date);
	mois=atoi(temp);
	strftime(temp,5,"%d",&date);
	quant=atoi(temp);

	sprintf(sJour,"%s",ttjour[jour]);
	sprintf(sMois,"%s",ttmois[mois-1]);

	strftime(fin,20,"%Y %H:%M",&date);	/*date locale*/
	sprintf(datfr,"%s %i %s %s",sJour,quant,sMois,fin);
	datfr[strlen(datfr)]='\0';
	return (datfr);
}


char *getnbusers() {
	register int n,i;
	register int entries=0;
	int nb_users_max=200;
	int users[nb_users_max];
	int usr_rep=0;
	struct stat stat_buf;
	struct dirent **namelist;
 
	n = scandir("/proc", &namelist, 0, alphasort);
	chdir("/proc");
	if (n < 0)
		perror("scandir");
	else
	while(n--){
		stat(namelist[n]->d_name,&stat_buf);
	/*
		if (stat(namelist[n]->d_name,&stat_buf)==-1)
			perror("stat");
			*/
		if ((stat_buf.st_mode & S_IFMT)==S_IFDIR){
			usr_rep=0;
			for (i=0;i<entries;i++)
				if (users[i]==stat_buf.st_uid)
					usr_rep=1;
			if (usr_rep==0){	
				users[entries]=stat_buf.st_uid; 
				if (stat_buf.st_uid >20)
				entries++; 		  
			}	
		}						
	}
	if (entries<2)
		sprintf(nbuser,"%i user",entries);
	else
		sprintf(nbuser,"%i users",entries);
	nbuser[strlen(nbuser)]='\0';
	return (nbuser);
}


char *avrg(){
	int ret_sysinfo;
	struct sysinfo info;

	ret_sysinfo=sysinfo(&info);
	sprintf(strAvg,"%.2lf",(double)info.loads[0]/65536);
	strAvg[strlen(strAvg)]='\0';
	return (strAvg);
}

void main(){
	char texte[250];

	puts("\nVersion 2.5 de barre");
	puts("merci de signaler les bugs eventuels a:");
	puts("dams@altavista.net");
	puts("-----------------------------------");
	puts("Ne lancez pas plusieurs fois ce programme,");
	puts("la redondance d'informations");
	puts("ne donne pas plus d'informations!\n");

	for(;;){
		if (getppid()==1) exit(1);
		sprintf(texte,"%s / %s / avg: %s / %s",datefr(),getnbusers(),avrg(),mail());
		ecritbarre(texte);
	}
}
